<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task35.20 update user form</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script> 
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script> 
</head>
<body>
    <div class = "container jumbotron">
        <div class = "text-center mb-4">
            <h3>Chi tiết user</h3>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Name</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-name" class = "form-control" placeholder="Nhập Name...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Username</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-username" class = "form-control" placeholder="Nhập username...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Email</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-email" class = "form-control" placeholder="Nhập email...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <div class = "row">
                    <div class = "col-sm-6">
                        <label>Address</label>
                    </div>
                    <div class = "col-sm-6">
                        <label>Street</label>
                    </div>
                </div>
            </div>
            <div class = "col-sm-8">
                <input id="input-street" class = "form-control">
            </div>            
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <div class = "row">
                    <div class = "col-sm-6">
                    </div>
                    <div class = "col-sm-6">
                        <label>Suite</label>
                    </div>
                </div>
            </div>
            <div class = "col-sm-8">
                <input id="input-suite" class = "form-control">
            </div>            
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <div class = "row">
                    <div class = "col-sm-6">
                    </div>
                    <div class = "col-sm-6">
                        <label>City</label>
                    </div>
                </div>
            </div>
            <div class = "col-sm-8">
                <input id="input-city" class = "form-control">
            </div>            
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <div class = "row">
                    <div class = "col-sm-6">
                    </div>
                    <div class = "col-sm-6">
                        <label>Zip code</label>
                    </div>
                </div>
            </div>
            <div class = "col-sm-8">
                <input id="input-zipcode" class = "form-control">
            </div>            
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <div class = "row">
                    <div class = "col-sm-6">
                    </div>
                    <div class = "col-sm-6">
                        <label>Geo-lat</label>
                    </div>
                </div>
            </div>
            <div class = "col-sm-8">
                <input id="input-geo-lat" class = "form-control">
            </div>            
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <div class = "row">
                    <div class = "col-sm-6">
                    </div>
                    <div class = "col-sm-6">
                        <label>Geo-lng</label>
                    </div>
                </div>
            </div>
            <div class = "col-sm-8">
                <input id="input-geo-lng" class = "form-control">
            </div>            
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Phone</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-phone" class = "form-control">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Website</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-website" class = "form-control">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <div class = "row">
                    <div class = "col-sm-6">
                        <label>Company</label>
                    </div>
                    <div class = "col-sm-6">
                        <label>Name</label>
                    </div>
                </div>
            </div>
            <div class = "col-sm-8">
                <input id="input-company-name" class = "form-control">
            </div>            
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <div class = "row">
                    <div class = "col-sm-6">
                    </div>
                    <div class = "col-sm-6">
                        <label>Catch Phrase</label>
                    </div>
                </div>
            </div>
            <div class = "col-sm-8">
                <input id="input-catch-phrase" class = "form-control">
            </div>            
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <div class = "row">
                    <div class = "col-sm-6">
                    </div>
                    <div class = "col-sm-6">
                        <label>Bs</label>
                    </div>
                </div>
            </div>
            <div class = "col-sm-8">
                <input id="input-bs" class = "form-control">
            </div>            
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
            </div>
            <div class = "col-sm-8">
                <button id = "btn-update" class = "btn btn-success w-25"> Update</button>
                <button id = "btn-cancel" class = "btn btn-danger w-25"> Cancel</button>
            </div>
        </div>       
    </div>
</body>
<script>
     "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();
        $("#btn-update").click(function(){  //gán sự kiện cho nút update  
            onBtnUpdateClick(); 
        });
        $("#btn-cancel").click(function(){  //gán sự kiện cho nút hủy  
            onBtnCancelClick(); 
        });
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện tải trang
    function onPageLoading(){
        "use strict";
        //thu thập dữ liệu từ query string
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        //search param
        var vId = vUrl.searchParams.get("id");
        console.log("Id của user là: " + vId);
        callApiGetDataUserById(vId);
    }
    //hàm xử lý sự kiện update user
    function onBtnUpdateClick(){
        //b1: thu thập dữ liệu từ query string
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        //search param
        var vId = vUrl.searchParams.get("id");
        //b2: kiểm tra dữ liệu
        var vCheck = validateUserId(vId);
        if (vCheck){
            //gọi API
            callApiUpdateUser(vId);
        };
        
    }
    //hàm xử lý sự kiện cancel
    function onBtnCancelClick(){
        const vUSER_LIST_URL = "userList.html";
        window.location.href = vUSER_LIST_URL;
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function callApiGetDataUserById(paramUserId) {
        $.ajax({
            url: "https://jsonplaceholder.typicode.com/users/" + paramUserId,
            type: "GET",
            dataType: "json",
            success: function (paramDataUserObj){
                console.log(paramDataUserObj);
                showDataUserToForm(paramDataUserObj);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            },
        });        
    }
    //hàm hiển thị dữ liệu lên form
    function showDataUserToForm(paramDataUserObj){
        "use strict";
        $("#input-name").val(paramDataUserObj.name);
        $("#input-username").val(paramDataUserObj.username);
        $("#input-email").val(paramDataUserObj.email);
        $("#input-suite").val(paramDataUserObj.address.suite);
        $("#input-street").val(paramDataUserObj.address.street);
        $("#input-city").val(paramDataUserObj.address.city);
        $("#input-zipcode").val(paramDataUserObj.address.zipcode);
        $("#input-geo-lat").val(paramDataUserObj.address.geo.lat);
        $("#input-geo-lng").val(paramDataUserObj.address.geo.lng);
        $("#input-phone").val(paramDataUserObj.phone);
        $("#input-website").val(paramDataUserObj.website);
        $("#input-company-name").val(paramDataUserObj.company.name);
        $("#input-catch-phrase").val(paramDataUserObj.company.catchPhrase);
        $("#input-bs").val(paramDataUserObj.company.bs);
    }
    //hàm validate user Id
    function validateUserId(paramUserId){
        if (paramUserId == null){
            alert("Chưa có tham số userId");
            return false;
        }
        return true;
    }
    //hàm gọi API cập nhật user
    function callApiUpdateUser(paramUserId){
        $.ajax({
            url: "https://jsonplaceholder.typicode.com/users/" + paramUserId,
            type: "PUT",
            dataType: "json",
            success: function (paramDataUserObj){
                console.log("User đã được update!");                
                displayUserUpdateResult(paramDataUserObj);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            },
        });
    }
    //khai báo hàm hiển thị thông tin user đã cập nhật
    function displayUserUpdateResult(paramDataUserObj){
        console.log(paramDataUserObj);
        const vUSER_LIST_URL = "userList.html";
        window.location.href = vUSER_LIST_URL;
    }

</script>
</html>